//
//  KouponDetailViewController.m
//  MyKouponSample
//
//  Created by Brian Reinhart on 9/30/13.
//  Copyright (c) 2013 Koupon Media. All rights reserved.
//

#import "KouponDetailViewController.h"
#import "AppDelegate.h"

@interface KouponDetailViewController () {
    Koupon* kouponSDK;
    KMRequest* request;
}

@end

@implementation KouponDetailViewController
@synthesize index;
@synthesize data;

//This will be updated whenever you call "Get Offer List"
static NSString* offerId = @"1337";

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        AppDelegate* appDelegate = (AppDelegate*)[[UIApplication sharedApplication] delegate];
        kouponSDK = appDelegate.kouponSDK;
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    //Show the navigation bar for this view
    if(!kouponSDK) {
        AppDelegate* appDelegate = (AppDelegate*)[[UIApplication sharedApplication] delegate];
        kouponSDK = appDelegate.kouponSDK;
    }
    
    //Check to see if the consumerID has been set and the Call is not "Create Consumer"
    
    [activity startAnimating];
    AppDelegate* appDelegate = (AppDelegate*)[[UIApplication sharedApplication] delegate];
    data = appDelegate.apiData;
    NSMutableDictionary* record = [data.apiList objectAtIndex:index.row];
        
    request = [self determineAPIToCall:record forIndex:index.row];

    [request sendRequestAsyncOnSuccess:^(NSMutableDictionary *response) {
        
        NSData* jsonData = [NSJSONSerialization dataWithJSONObject:[record objectForKey:@"PostData"] options:0 error:nil];
        NSString* jsonString = [[NSString alloc] initWithBytes:[jsonData bytes] length:[jsonData length] encoding:NSUTF8StringEncoding];
        
        postTextView.text = jsonString;
        
        if(request) {
            urlTextView.text = request.url;
            if(response) {
                jsonData = [NSJSONSerialization dataWithJSONObject:response options:0 error:nil];
            }
            if(jsonData) {
                jsonString = [[NSString alloc] initWithBytes:[jsonData bytes] length:[jsonData length] encoding:NSUTF8StringEncoding];
                responseTextView.text = jsonString;
            }
        }
        
        if ( [[record objectForKey:@"DisplayName"] isEqualToString:@"Create Consumer" ])
        {
            if (response) {
                Koupon.consumerId = [response objectForKey:@"consumer_identity"];
            }
        }
        if ( [[record objectForKey:@"DisplayName"] isEqualToString:@"Get Offer List" ])
        {
            if (response && [(NSMutableArray*)[response objectForKey:@"Offers"] count] > 0) {
                //                [((NSMutableDictionary*)record) setObject:[[(NSMutableArray*)[response objectForKey:@"Offers"] objectAtIndex:0]
                //                                                           objectForKey: @"offerId"] forKey:@"OfferID"];
                offerId = [NSString stringWithFormat:@"%@",[[[response objectForKey:@"Offers"] objectAtIndex:0] objectForKey:@"offerId"]];
                NSMutableArray* tmpArray = [[NSMutableArray alloc] init];
                for (NSDictionary* node in [response objectForKey:@"Offers"]) {
                    [tmpArray addObject:[node objectForKey:@"offerId"]];
                }
                appDelegate.apiData.offerList = [tmpArray copy];
                
            }
        }
        [activity stopAnimating];
        
    } OnFailure:^(NSMutableDictionary * response) {
        
    }];
    apiLabel.text = [record objectForKey:@"DisplayName"];
    
    
    
    
	// Do any additional setup after loading the view.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

-(void) prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender
{


}

-(KMRequest*) determineAPIToCall: (NSMutableDictionary*) record forIndex: (int) anIndex
{
    //Quick and Dirty way to determine the API to call and return a KMRequest object
    switch (anIndex) {
        case 0:
            return [kouponSDK updateConsumerData:[record objectForKey:@"PostData"] withOptionalQueryData:nil];
            break;
        case 1:
            return [kouponSDK getConsumerData:nil];
            break;
        case 2:
            return [kouponSDK getConsumerOfferList:[record objectForKey:@"FilterData"] withOptionalQueryData:nil];
            break;
        case 3:
            return [kouponSDK getConsumerOffer:offerId withOptionalData:nil];
            break;
        case 4:
        case 5:
            return [kouponSDK updateConsumerState:[record objectForKey:@"State"] forOffer:offerId withOptionalData:nil];
            break;
        case 6:
            return [kouponSDK addOfferToConsumer:offerId withOptionalData:nil];
            break;
        case 7:
            return [kouponSDK addMultipleOffersToConsumer:[record objectForKey:@"Offers"] withOptionalData:nil];
            break;
        default:
            return nil;
            break;
    }
}

@end
